package me.Irock23.SRPEX;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.logging.Logger;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.util.config.Configuration;

import ru.tehkode.permissions.PermissionGroup;
import ru.tehkode.permissions.PermissionManager;
import ru.tehkode.permissions.bukkit.PermissionsEx;

public class SetRankPEX extends JavaPlugin {
	protected static Configuration config;
	public static PermissionManager permissionsex;
	public static SetRankPEX plugin;
	public final Logger log = Logger.getLogger("Minecraft");
	public boolean cancelE;
	
	@Override
	public void onEnable() {
		setupPermissions();
		if (cancelE == true) {
			return;
		}
		config = getConfiguration();
		File yml = new File(getDataFolder() + "/config.yml");
		if (!yml.exists()) {
			firstRunSettings();
		}
		config.load();
		PluginDescriptionFile pdffile = this.getDescription();
		log.info("[SRPEX] "+ pdffile.getFullName() + " is now enabled.");
	}
	
	@Override
	public void onDisable() {
		PluginDescriptionFile pdffile = this.getDescription();
		log.info("[SRPEX] " + pdffile.getName() + " is now disabled.");
	}
	
	private void setupPermissions() {
		if (this.getServer().getPluginManager().isPluginEnabled("PermissionsEx")) {
			Plugin permissionsPlugin = this.getServer().getPluginManager().getPlugin("PermissionsEx");
			permissionsex = PermissionsEx.getPermissionManager();
			log.info("[SRPEX] Found " + ((PermissionsEx)permissionsPlugin).getDescription().getFullName() + " and is good to go");
		} else {
			log.severe("[SRPEX] PermissionsEx not detected, disabling SetRankPEX");
			this.setEnabled(false);
			cancelE = true;
			return;
		}
	}
	
	private void firstRunSettings() {
        try {
        	getDataFolder().mkdir();
    		FileWriter fstream = new FileWriter(getDataFolder() + "/config.yml");
    	    BufferedWriter out = new BufferedWriter(fstream);
            out.write("allow-ops-changes: true\n");
            out.write("broadcast-rank-change: true\n");
            out.write("broadcast-message: '+player is now a(n) +group'");
            out.close();
        }
        catch (Exception e) {
               log.severe("[SRPEX] Failed to create config file!");
        }
	}
	
	public boolean onCommand(CommandSender cs, Command cmd, String alias, String[] args) {
		if (cmd.getName().equalsIgnoreCase("setrank")) {
			if (args.length != 2) {
				return false;
			}
			if (cs instanceof Player) {
				Player player = (Player)cs;
				if (hasSetRank(player, args[1])) {
						SetRank(cs, args[0], args[1]);
				} else if (config.getBoolean("allow-ops-changes", true) && player.isOp()) {
						SetRank(cs, args[0], args[1]);
				} else {
					cs.sendMessage(ChatColor.YELLOW + "[SRPEX] " + ChatColor.RED + "You do not have permission to do this!" );
				}
			} else {
					SetRank(cs, args[0], args[1]);
			}
			return true;
		}
		if (cmd.getName().equalsIgnoreCase("srpexreload")) {
			if (args.length > 0) {
				return false;
			}
			PluginDescriptionFile pdffile = this.getDescription();
			if (cs instanceof Player) {
				Player player = (Player)cs;
				if (hasReload(player)) {
					config.load();
					cs.sendMessage(ChatColor.YELLOW + "[SRPEX] " + pdffile.getName() + " was succesfully reloaded");
					log.info("[SRPEX] " + pdffile.getName() + " was succesfully reloaded");
				} else if (config.getBoolean("allow-ops-changes", true) && player.isOp()) {
					config.load();
					cs.sendMessage(ChatColor.YELLOW + "[SRPEX] " + pdffile.getName() + " was succesfully reloaded");
					log.info("[SRPEX] " + pdffile.getName() + " was succesfully reloaded");
				} else {
					cs.sendMessage(ChatColor.YELLOW + "[SRPEX] " + ChatColor.RED + "You do not have permission to do this!" );
				}
			} else {
				config.load();
				cs.sendMessage(ChatColor.YELLOW + "[SRPEX] " + pdffile.getName() + " was succesfully reloaded");
				log.info("[SRPEX] " + pdffile.getName() + " was succesfully reloaded");
			}
			return true;
		}
		return false;
	}
	
	public void SetRank(CommandSender cs, String Name, String Group) {
		Player player = getServer().getPlayer(Name);
		if (player == null || !player.isOnline()) {
			cs.sendMessage(ChatColor.YELLOW + "[SRPEX] " + Name + " was not found, make sure they are online!");
			return;
		}
        if (!permissionsex.getUser(Name).inGroup(Group)) {
        	PermissionGroup[] groups;
    		Group = Group.replace("_", " ");
    		groups = new PermissionGroup[]{permissionsex.getGroup(Group)};
    	
    		permissionsex.getUser(Name).setGroups(groups);
        	if (config.getBoolean("broadcast-rank-change", true)) {
        		String message = config.getString("broadcast-message", "+player is now a(n) +group");
        		message = message.replace("+player", Name);
        		message = message.replace("+group", Group);
        		message = message.replace("&", "");
        		getServer().broadcastMessage(ChatColor.YELLOW + "[SRPEX] " + ChatColor.BLUE + message);
        	}
        }
        else {
        	cs.sendMessage(ChatColor.YELLOW + "[SRPEX] " + ChatColor.RED + Name + " is already in that group!");
        }

	}
	
	public boolean hasSetRank(Player player, String group) {
		String perms = "srpex.setrank." + group.toLowerCase();
		if (permissionsex.has(player, perms)) {
			return true;
		} else if (permissionsex.has(player, "srpex.setrank.*")) {
			return true;
		} else if (permissionsex.has(player, "srpex.*")) {
			return true;
		}
		return false;
	}
	
	public boolean hasReload(Player player) {
		if (permissionsex.has(player, "srpex.reload")) {
			return true;
		} else if (permissionsex.has(player, "srpex.*")) {
			return true;
		}
		return false;
	}
}
